

# ListResourceGroupingRecommendations
<a name="API_ListResourceGroupingRecommendations"></a>

Lists the resource grouping recommendations suggested by AWS Resilience Hub for your application.

## Request Syntax
<a name="API_ListResourceGroupingRecommendations_RequestSyntax"></a>

```
GET /list-resource-grouping-recommendations?appArn=appArn&maxResults=maxResults&nextToken=nextToken HTTP/1.1
```

## URI Request Parameters
<a name="API_ListResourceGroupingRecommendations_RequestParameters"></a>

The request uses the following URI parameters.

 ** [appArn](#API_ListResourceGroupingRecommendations_RequestSyntax) **   <a name="resiliencehub-ListResourceGroupingRecommendations-request-uri-appArn"></a>
Amazon Resource Name (ARN) of the AWS Resilience Hub application. The format for this ARN is: arn:`partition`:resiliencehub:`region`:`account`:app/`app-id`. For more information about ARNs, see [ Amazon Resource Names (ARNs)](https://docs.aws.amazon.com/general/latest/gr/aws-arns-and-namespaces.html) in the * AWS General Reference* guide.  
Pattern: `arn:(aws|aws-cn|aws-iso|aws-iso-[a-z]{1}|aws-us-gov):[A-Za-z0-9][A-Za-z0-9_/.-]{0,62}:([a-z]{2}-((iso[a-z]{0,1}-)|(gov-)){0,1}[a-z]+-[0-9]):[0-9]{12}:[A-Za-z0-9/][A-Za-z0-9:_/+.-]{0,1023}` 

 ** [maxResults](#API_ListResourceGroupingRecommendations_RequestSyntax) **   <a name="resiliencehub-ListResourceGroupingRecommendations-request-uri-maxResults"></a>
Maximum number of grouping recommendations to be displayed per AWS Resilience Hub application.  
Valid Range: Minimum value of 1. Maximum value of 100.

 ** [nextToken](#API_ListResourceGroupingRecommendations_RequestSyntax) **   <a name="resiliencehub-ListResourceGroupingRecommendations-request-uri-nextToken"></a>
Null, or the token from a previous call to get the next set of results.  
Pattern: `\S{1,2000}` 

## Request Body
<a name="API_ListResourceGroupingRecommendations_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_ListResourceGroupingRecommendations_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "groupingRecommendations": [ 
      { 
         "confidenceLevel": "string",
         "creationTime": number,
         "groupingAppComponent": { 
            "appComponentId": "string",
            "appComponentName": "string",
            "appComponentType": "string"
         },
         "groupingRecommendationId": "string",
         "recommendationReasons": [ "string" ],
         "rejectionReason": "string",
         "resources": [ 
            { 
               "logicalResourceId": { 
                  "eksSourceName": "string",
                  "identifier": "string",
                  "logicalStackName": "string",
                  "resourceGroupName": "string",
                  "terraformSourceName": "string"
               },
               "physicalResourceId": { 
                  "awsAccountId": "string",
                  "awsRegion": "string",
                  "identifier": "string",
                  "type": "string"
               },
               "resourceName": "string",
               "resourceType": "string",
               "sourceAppComponentIds": [ "string" ]
            }
         ],
         "score": number,
         "status": "string"
      }
   ],
   "nextToken": "string"
}
```

## Response Elements
<a name="API_ListResourceGroupingRecommendations_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [groupingRecommendations](#API_ListResourceGroupingRecommendations_ResponseSyntax) **   <a name="resiliencehub-ListResourceGroupingRecommendations-response-groupingRecommendations"></a>
List of resource grouping recommendations generated by AWS Resilience Hub.  
Type: Array of [GroupingRecommendation](API_GroupingRecommendation.md) objects

 ** [nextToken](#API_ListResourceGroupingRecommendations_ResponseSyntax) **   <a name="resiliencehub-ListResourceGroupingRecommendations-response-nextToken"></a>
Null, or the token from a previous call to get the next set of results.  
Type: String  
Pattern: `\S{1,2000}` 

## Errors
<a name="API_ListResourceGroupingRecommendations_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permissions to perform the requested operation. The user or role that is making the request must have at least one IAM permissions policy attached that grants the required permissions.  
HTTP Status Code: 403

 ** InternalServerException **   
This exception occurs when there is an internal failure in the AWS Resilience Hub service.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
This exception occurs when the specified resource could not be found.    
 ** resourceId **   
The identifier of the resource that the exception applies to.  
 ** resourceType **   
The type of the resource that the exception applies to.
HTTP Status Code: 404

 ** ThrottlingException **   
This exception occurs when you have exceeded the limit on the number of requests per second.    
 ** retryAfterSeconds **   
The number of seconds to wait before retrying the operation.
HTTP Status Code: 429

 ** ValidationException **   
This exception occurs when a request is not valid.  
HTTP Status Code: 400

## See Also
<a name="API_ListResourceGroupingRecommendations_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/resiliencehub-2020-04-30/ListResourceGroupingRecommendations) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/resiliencehub-2020-04-30/ListResourceGroupingRecommendations) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/resiliencehub-2020-04-30/ListResourceGroupingRecommendations) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/resiliencehub-2020-04-30/ListResourceGroupingRecommendations) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/resiliencehub-2020-04-30/ListResourceGroupingRecommendations) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/resiliencehub-2020-04-30/ListResourceGroupingRecommendations) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/resiliencehub-2020-04-30/ListResourceGroupingRecommendations) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/resiliencehub-2020-04-30/ListResourceGroupingRecommendations) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/resiliencehub-2020-04-30/ListResourceGroupingRecommendations) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/resiliencehub-2020-04-30/ListResourceGroupingRecommendations) 